/*************************************************
*   Super Awesome LED Lab Coat Controller
*      by Bill Porter
*
*     Copyright (c) 2010 billporter.info
*   (please link back if you use this code!)
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License version 2 as
*   published by the Free Software Foundation.
*
*
*
*
**************************************************/

/*
The ides is each pattern is stored as a function, called at random
If fading is involved,
the pattern function will fill an array with duty cycles, then call ledfade() to pulse those LED's with array values once.
It's up to the function to repeate pusles and reduce duty cycles for a fade

*/




char dir = 0;
int dimvals[8];
int dimvalstemp[8];



void setup()
{
  pinMode(2, OUTPUT);
  pinMode(3, OUTPUT);
  pinMode(4, OUTPUT);
  pinMode(5, OUTPUT);
  pinMode(6, OUTPUT);
  pinMode(7, OUTPUT);
  pinMode(8, OUTPUT);
  pinMode(9, OUTPUT);
  
  randomSeed(analogRead(0));

}

void loop()
{
/*
 dimvals[0] = 5;
 dimvals[1] = 15; 
 dimvals[2] = 35;
 dimvals[3] = 50;
 dimvals[4] = 100;
 dimvals[5] = 255;
 
 
*/
 
 
 
// show5();
//pattern4();
    patternSelect(random(1,16));
  //for (dir = 0; dir < 15; dir++)
  //{
  //  patternSelect(dir);
 // }
 //show1();
 
 //pattern3();
 
     
 
 /*
 allOn();
 delayMicroseconds(22);
 allOff();
 delayMicroseconds(5678);
  */
}

void patternSelect(int pattern)
{
  //pattern = pattern - 5;
  switch (pattern)
  {
    case (1):
    pattern1();
    break;
    case (2):
    pattern2();
    break;
    case (3):
    pattern3();
    break;
    case (4):
    pattern4();
    break;
    case (5):
    pattern5();
    break;
    case (6):
    pattern6();
    break;
    case (7):
    pattern7();
    break;
    /*case (8):
    pattern8();
    break;*/
    case (9):
    pattern9();
    break;
    case (10):
    pattern10();
    break;
    case (11):
    pattern11();
    break;
    case (12):
    pattern12();
    break;
    case (13):
    pattern13();
    break;
    case (14):
    pattern14();
    break;
    case (15):
    pattern15();
    break;
    case (16):
    pattern16();
    break;
    default:
    break;
  }
}
    
    
    
void allOn()
{
  digitalWrite(2, HIGH);   // sets the LED on
  digitalWrite(3, HIGH);
  digitalWrite(4, HIGH);
  digitalWrite(5, HIGH);
  digitalWrite(6, HIGH);
  digitalWrite(7, HIGH);
  digitalWrite(8, HIGH);
  digitalWrite(9, HIGH);
}

void allOff()
{
  digitalWrite(2, LOW);    // sets the LED off
  digitalWrite(3, LOW);
  digitalWrite(4, LOW);
  digitalWrite(5, LOW);
  digitalWrite(6, LOW);
  digitalWrite(7, LOW);
  digitalWrite(8, LOW);
  digitalWrite(9, LOW);
}

void pattern1()
{
  for (int rep = 0; rep < 4; rep++)
  {
  show1();
  }
}
void show1()
{
  char number = 2;
  
  while (number <= 9)
  {
    dimvals[(number - 2)]= 255;
    digitalWrite(number++, HIGH);
    
    delay(50);
  }
  while (number > 2)
  {
    
    
   for(int z=0; z<8; z++)
    {
       for (int c=0; c<8; c++) //subtract from every led
        {
          if (dimvals[c] > 0 && c > (number - 4))
            dimvals[c] = dimvals[c] - 10;
        }
       ledfade(dimvals);
    } 
 
    --number;
    //delay(50);
  }
}
void pattern2()
{
  for (int rep = 0; rep < 4; rep++)
  {
  show2();
  }
}
void show2()
{
  char number = 9;
  
  while (number >= 2)
  {
    dimvals[(number - 2)]= 255;
    digitalWrite(number--, HIGH);
    delay(50);
  }
  while (number < 9)
  {
    
    for(int z=0; z<8; z++)
    {
       for (int c=0; c<8; c++) //subtract from every led
        {
          if (dimvals[c] > 0 && c < (number + 1))
            dimvals[c] = dimvals[c] - 10;
        }
       ledfade(dimvals);
    } 
 
    ++number;
    
    //digitalWrite(++number, LOW);
    //delay(50);
  }
}
void pattern3()
{
  for (int rep = 0; rep < 4; rep++)
  {
  show1();
  show2();
  }
}

void pattern4()
{
  int led=0;
for (int x=85; x >= 0; x--) //each step (led)
 {
   led = random(0,8); //randomly select one to put to full brightness
   for(int z=0; z<8; z++) //repeat the subtracts z times for 1 step
    {
       for (int c=0; c<8; c++) //subtract from every led a certian amount of duty cycle
        {
          if (dimvals[c] > 0)
            dimvals[c] = dimvals[c] - 10;
        }
       dimvals[led] = 250;
       ledfade(dimvals); //pulse all once
    } 
 }
  
/*  
int dur = 0;
int led = 0;

while (dur++ < 300)
{
 led = random(2,10);
 digitalWrite(led, !digitalRead(led)); //toggle
 delay(30);
}*/
}

void pattern5()
{
  
  
  for (int rep = 0; rep < 4; rep++)
  {
   show5();
  }
}  

void show5()
{
  int count = 2;
  while (count <=9)
  {
    digitalWrite(count, HIGH);
    if (count == 2)
      digitalWrite(9, LOW);
    else
      digitalWrite((count - 1), LOW);
    count++;
    delay(50);
  }
}
void pattern6()
{
  
  for (int rep = 0; rep < 4; rep++)
  {
    show6();
  }
}  
void show6()
{
  int count = 9;
  while (count >= 2)
  {
    digitalWrite(count, HIGH);
    if (count == 9)
      digitalWrite(2, LOW);
    else
      digitalWrite((count + 1), LOW);
    count--;
    delay(50);
  }
}
void pattern7()
{
  for (int rep = 0; rep < 4; rep++)
  {
  show5();
  show6();
  }
}

void pattern8()
{
  for (int rep = 0; rep < 4; rep++)
  {
  allOn();
  delay(500);                  // waits for a second
  allOff();
  delay(500);                  // waits for a second
 }
}

void pattern9()
{
for (int rep = 0; rep < 4; rep++)
  {
    show9();
  }
}
void show9()
{
  
  for (int x=0; x < 8; x++) //one for each led
 {
   for(int z=0; z<8; z++)// run 8 cycles on the set for each led
    {
       for (int c=0; c<8; c++) //subtract from every led
        {
          if (dimvals[c] > 0)
            dimvals[c] = dimvals[c] - 10;
        }
       dimvals[x] = 250;
       ledfade(dimvals); //pulse each cycle
    } 
 }
  
  /*int divdor = 0;
int ledlow = 0;
int ledmed = 0;
int ledmedhi = 0;
   for (int count = 0; count < 1400; count++)
  {
    
    divdor = count / 175;
    divdor = divdor + 2;
    digitalWrite(divdor, HIGH);
    ledmedhi = --divdor;
    if (ledmedhi < 2)
      ledmedhi = ledmedhi + 8;
    
    ledmed = --divdor;
    if (ledmed < 2)
      ledmed = ledmed + 8;
    ledlow = --divdor;
    if (ledlow < 2)
      ledlow = ledlow + 8;
    digitalWrite(ledmedhi, HIGH);
    digitalWrite(ledmed, HIGH);
    digitalWrite(ledlow, HIGH);
    delayMicroseconds(4);
    digitalWrite(ledlow, LOW);
    delayMicroseconds(16);
    digitalWrite(ledmed, LOW);
     delayMicroseconds(32);
    digitalWrite(ledmedhi, LOW);
    delayMicroseconds(256);
  }*/
}
void pattern10()
{
 
for (int rep = 0; rep < 4; rep++)
  {
    show10();
  }
}
void show10()
{
  for (int x=7; x >= 0; x--) //each step (led)
 {
   for(int z=0; z<8; z++) //repeat the subtracts z times for 1 step
    {
       for (int c=0; c<8; c++) //subtract from every led
        {
          if (dimvals[c] > 0)
            dimvals[c] = dimvals[c] - 10;
        }
       dimvals[x] = 250;
       ledfade(dimvals);
    } 
 }
  /*
  int divdor = 0;
int ledlow = 0;
int ledmed = 0;
int ledmedhi = 0;
   for (int count = 1400; count > 0; count--)
  {
    

    divdor = count / 175;
    divdor = divdor + 2;
    digitalWrite(divdor, HIGH);
    ledmedhi = ++divdor;
    if (ledmedhi > 9)
      ledmedhi = ledmedhi + 8;
    ledmed = ++divdor;
    if (ledmed > 9)
      ledmed = ledmed - 8;
    ledlow = ++divdor;
    if (ledlow > 9)
      ledlow = ledlow - 8;
    digitalWrite(ledmedhi, HIGH);
    digitalWrite(ledmed, HIGH);
    digitalWrite(ledlow, HIGH);
    delayMicroseconds(4);
    digitalWrite(ledlow, LOW);
    delayMicroseconds(16);
    digitalWrite(ledmed, LOW);
    delayMicroseconds(32);
    digitalWrite(ledmedhi, LOW);
    delayMicroseconds(256);
  }*/
}
void pattern11()
{
  for (int rep = 0; rep < 4; rep++)
  {
show9();
show10();
  }
}

void pattern12()
{
  
  for (int rep = 0; rep < 4; rep++)
  {
  show12();
  }
}
void show12()
{
  int count = 2;
  allOn();
  while (count <=9)
  {
    digitalWrite(count, LOW);
    if (count == 2)
      digitalWrite(9, HIGH);
    else
      digitalWrite((count - 1), HIGH);
    count++;
    delay(50);
  }
}
void pattern13()
{

 for (int rep = 0; rep < 4; rep++)
  {
 show13();
  }
}
void show13()
{
   int count = 9;
  allOn();
  while (count >= 2)
  {
    digitalWrite(count, LOW);
    if (count == 9)
      digitalWrite(2, HIGH);
    else
      digitalWrite((count + 1), HIGH);
    count--;
    delay(50);
  }
}
void pattern14()
{
  for (int rep = 0; rep < 4; rep++)
  {
  show12();
  show13();
  }
}

void pattern15()
{
  for (int rep = 0; rep < 4; rep++)
  {
   for (int count = 1; count < 1000; count=count+2)
  {
    allOn();
    delayMicroseconds(count);
    allOff();
    delayMicroseconds((1005 - count));
  }
for (int count = 1000; count > 0; count=count-2)
  {
    allOn();
    delayMicroseconds(count);
    allOff();
    delayMicroseconds((1005 - count));
  }
 }
}

void pattern16()
{
  allOff();
  for (int rep = 0; rep < 4; rep++)
  {
    digitalWrite(2, HIGH);
    digitalWrite(9, HIGH);
    delay(150);
    for (int count = 2; count <=4; count++)
    {  
      
      digitalWrite((count + 1), HIGH);
      digitalWrite((10 - count), HIGH);
      digitalWrite((count), LOW);
      digitalWrite((11 - count), LOW);
     delay(150);
    }
    allOff();
  }
}
   
void ledfade(int *dimvals)
{
  
 int cycle = 1;
 //unsigned long start = 0;
 //start = micros();
 memcpy(dimvalstemp, dimvals, sizeof(dimvalstemp));
 /*int temp = 0;
 int offlen = 0;
 for(int i = 1; i < 256; i++)
 {
   temp = 22 * i;
   offlen = 5700 - temp;
   
     allOn();
     delayMicroseconds(temp);
     allOff();
     delayMicroseconds(offlen);
     */
     
     for(int y = 0; y < 9; y++)   //turn on all LEDS that need to be on for the start of the PWM cycle
       {
         if (dimvalstemp[y] > 0)
           digitalWrite((y+2), HIGH);
       }
     while (cycle < 256)
     {
       for(int y = 0; y < 9; y++)
       {
         if (dimvalstemp[y] < cycle)  //turn off channel when the duty cycle matches what is requested
         {
           digitalWrite((y+2), LOW);
           dimvalstemp[y] = 256;    //set high to avoid repeated digitalWrite functions
         }
       }
       cycle++;
       delayMicroseconds(15);  //delay a bit. I don't remember why
       
     }
    //if ((micros() - start) > 5700)
        //digitalWrite(13, HIGH);
    //else
        //digitalWrite(13, LOW);  
 
}
